
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.Timer;
import javax.swing.border.Border;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * AutomaatUI.java
 *
 * Gebruikersinterface van de automaat
 *
 * Created on 30-mrt-2009, 10:38:33
 * Versie:
 * v3 29-apr-2009
 * v4 12-5-2009
 * v5 9-6-2009 (=v2 van project, een nieuwe 'release')
 *
 * v5: extra panel (jPanel_2) toegevoegd met een tussenstap waarin
 * de naam wordt opgeslagen om de voorkeuren vast te leggen
 * Dit demonstreerd het gebruik van meerdere Panels in een Wizard-achtige
 * opzet nog iets beter.
 * Ook wordt in oa. setButtonOutOfStock() de knoppen op een andere manier
 * aangesproken, via de getComponent() methode van het Panel waar de knoppen
 * in zitten.
 *
 * De gebruikersinterface heeft de volgende methoden die door
 * de controller gebruikt kunnen worden:
 *
 * displayMessage(String)   laat een boodschap op het scherm voor de klant zien
 * setButtonLabel(int x, String label)  stel het label van knop nr x in
 * setButtonOutOfStock(int x)   vertel dat betreffende product op is
 *
 */
/**
 *
 * @author fjodor
 */
public class AutomaatUI extends javax.swing.JFrame {

    Controller controller;
    ProgressGlassPane progress;
    Timer timer;
    int progress_percentage;
    boolean hide_jPanel_2 = false;

    /** Creates new form AutomaatUI */
    public AutomaatUI() {
        initComponents();

        // initialiseer de controller na de initComponents()
        // omdat deze de buttons nodig heeft!
        // maak een nieuwe Controller:
        controller = new Controller(this);


        // vertel de gebruiker dat de machine klaar is voor gebruik:
        displayMessage("Maak een keuze of betaal.");


        timer = new Timer(20, new TimerListener());
        progress = (ProgressGlassPane) jPanelProgress;
        progress.setVisible(false);
        jPanel_2.setVisible(false);
    }

    class TimerListener implements ActionListener {
        // Actie die wordt uitgevoerd als de Timer 'tikt'

        public void actionPerformed(ActionEvent e) {
            updateProgress();
        }
    }

    /**
     * Update de progress-bar
     */
    public void updateProgress() {
        progress.setProgress(progress_percentage++);
        if (progress_percentage >= 100) {
            stopProgress();
        }
    }

    /**
     * Stop de progress-bar, laat het onderliggende Panel weer zien
     */
    public void stopProgress() {
        progress.setVisible(false);
        jButtonStart.setEnabled(true);
        jButtonStart.setEnabled(true);
        timer.stop();
    }

    /**
     * Start de progress-bar.
     * We disabelen de buttons in het hoofd-panel omdat die anders de focus kunnen
     * krijgen en dan weer zichtbaar worden.
     * @param tekstboodschap die we laten zien
     */
    public void startProgress(String message) {
        jButtonStart.setEnabled(false);
        jButtonCancel.requestFocusInWindow();


        jPanelMain.setVisible(true);
        //jPanelMain.repaint();

        progress_percentage = 0;
        progress.setMessage(message);
        progress.setVisible(true);
        timer.start();

        System.out.println("Sterkte: "+jSlidersterkte.getValue());
        System.out.println("Suiker: "+jSliderSuiker.getValue());
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLayeredPane1 = new javax.swing.JLayeredPane();
        jPanel_2 = new javax.swing.JPanel();
        jButton_p2_verder = new javax.swing.JButton();
        jTextField2 = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jCheckBoxPanel2_verbergen = new javax.swing.JCheckBox();
        jPanelProgress = new ProgressGlassPane();
        jButtonCancel = new javax.swing.JButton();
        jPanelMain = new javax.swing.JPanel();
        jTextField1 = new javax.swing.JTextField();
        jButtonStart = new javax.swing.JButton();
        jPanelButtons = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();
        jButton6 = new javax.swing.JButton();
        jButton7 = new javax.swing.JButton();
        jButton8 = new javax.swing.JButton();
        jButton9 = new javax.swing.JButton();
        jButton10 = new javax.swing.JButton();
        jButton11 = new javax.swing.JButton();
        jButton12 = new javax.swing.JButton();
        jSlidersterkte = new javax.swing.JSlider();
        jLabel1 = new javax.swing.JLabel();
        jSliderSuiker = new javax.swing.JSlider();
        jLabel2 = new javax.swing.JLabel();
        jLabelBackground = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Theezetter v2");

        jPanel_2.setOpaque(false);

        jButton_p2_verder.setText("Verder >");
        jButton_p2_verder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_p2_verderActionPerformed(evt);
            }
        });

        jLabel3.setText("Voorkeuren opslaan");

        jLabel4.setText("Naam");

        jCheckBoxPanel2_verbergen.setText("Volgende keer verbergen");
        jCheckBoxPanel2_verbergen.setOpaque(false);

        javax.swing.GroupLayout jPanel_2Layout = new javax.swing.GroupLayout(jPanel_2);
        jPanel_2.setLayout(jPanel_2Layout);
        jPanel_2Layout.setHorizontalGroup(
            jPanel_2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel_2Layout.createSequentialGroup()
                .addContainerGap(296, Short.MAX_VALUE)
                .addComponent(jButton_p2_verder)
                .addGap(29, 29, 29))
            .addGroup(jPanel_2Layout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addComponent(jLabel3)
                .addContainerGap(273, Short.MAX_VALUE))
            .addGroup(jPanel_2Layout.createSequentialGroup()
                .addGap(73, 73, 73)
                .addGroup(jPanel_2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jCheckBoxPanel2_verbergen)
                    .addGroup(jPanel_2Layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 192, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(98, Short.MAX_VALUE))
        );
        jPanel_2Layout.setVerticalGroup(
            jPanel_2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel_2Layout.createSequentialGroup()
                .addGap(51, 51, 51)
                .addComponent(jLabel3)
                .addGap(33, 33, 33)
                .addGroup(jPanel_2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel_2Layout.createSequentialGroup()
                        .addComponent(jTextField2, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 242, Short.MAX_VALUE)
                        .addComponent(jCheckBoxPanel2_verbergen)
                        .addGap(59, 59, 59)
                        .addComponent(jButton_p2_verder)
                        .addGap(46, 46, 46))
                    .addGroup(jPanel_2Layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addContainerGap())))
        );

        jPanel_2.setBounds(0, 0, 400, 520);
        jLayeredPane1.add(jPanel_2, javax.swing.JLayeredPane.DEFAULT_LAYER);

        jPanelProgress.setBackground(new java.awt.Color(153, 153, 153));

        jButtonCancel.setText("Cancel");
        jButtonCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanelProgressLayout = new javax.swing.GroupLayout(jPanelProgress);
        jPanelProgress.setLayout(jPanelProgressLayout);
        jPanelProgressLayout.setHorizontalGroup(
            jPanelProgressLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelProgressLayout.createSequentialGroup()
                .addGap(166, 166, 166)
                .addComponent(jButtonCancel)
                .addContainerGap(169, Short.MAX_VALUE))
        );
        jPanelProgressLayout.setVerticalGroup(
            jPanelProgressLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelProgressLayout.createSequentialGroup()
                .addContainerGap(392, Short.MAX_VALUE)
                .addComponent(jButtonCancel)
                .addGap(105, 105, 105))
        );

        jPanelProgress.setBounds(0, 0, 400, 520);
        jLayeredPane1.add(jPanelProgress, javax.swing.JLayeredPane.DEFAULT_LAYER);

        jPanelMain.setBackground(new java.awt.Color(0, 0, 0));
        jPanelMain.setOpaque(false);

        jTextField1.setEditable(false);

        jButtonStart.setForeground(new java.awt.Color(255, 255, 255));
        jButtonStart.setIcon(new ImageIcon("green_button.png")); // green_button.png
        jButtonStart.setText("Start");
        jButtonStart.setBorderPainted(false);
        jButtonStart.setContentAreaFilled(false);
        jButtonStart.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButtonStart.setPressedIcon(new ImageIcon("green_button_pressed.png")); // green_button_pressed.png
        jButtonStart.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStartActionPerformed(evt);
            }
        });

        jPanelButtons.setOpaque(false);
        jPanelButtons.setLayout(new java.awt.GridLayout(0, 4));

        jButton1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setIcon(new ImageIcon("BlendCutOutImage.png")); // BlendCutOutImage.png
        jButton1.setText("jButton1");
        jButton1.setBorderPainted(false);
        jButton1.setContentAreaFilled(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton1);

        jButton2.setIcon(new ImageIcon("GoldenCutOutimage.png")); // GoldenCutOutimage.png
        jButton2.setText("jButton1");
        jButton2.setBorderPainted(false);
        jButton2.setContentAreaFilled(false);
        jButton2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton2);

        jButton3.setForeground(new java.awt.Color(255, 255, 255));
        jButton3.setIcon(new ImageIcon("LeafCutOutImage.png")); // LeafCutOutImage.png
        jButton3.setText("jButton1");
        jButton3.setBorderPainted(false);
        jButton3.setContentAreaFilled(false);
        jButton3.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton3);

        jButton4.setIcon(new ImageIcon("Mango-PerzikCutOutImageDetail.png")); // Mango-PerzikCutOutImageDetail.png
        jButton4.setText("jButton1");
        jButton4.setBorderPainted(false);
        jButton4.setContentAreaFilled(false);
        jButton4.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton4);

        jButton5.setIcon(new ImageIcon("NightCutOutImage.png")); // NightCutOutImage.png
        jButton5.setText("jButton1");
        jButton5.setBorderPainted(false);
        jButton5.setContentAreaFilled(false);
        jButton5.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton5);

        jButton6.setIcon(new ImageIcon("gr_GroenCutOutImage.png")); // gr_GroenCutOutImage.png
        jButton6.setText("jButton1");
        jButton6.setBorderPainted(false);
        jButton6.setContentAreaFilled(false);
        jButton6.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton6);

        jButton7.setIcon(new ImageIcon("Mango-PerzikCutOutImageDetail.png")); // Mango-PerzikCutOutImageDetail.png
        jButton7.setText("jButton1");
        jButton7.setBorderPainted(false);
        jButton7.setContentAreaFilled(false);
        jButton7.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton7.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton7ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton7);

        jButton8.setIcon(new ImageIcon("MorningCutOutImage.png")); // MorningCutOutImage.png
        jButton8.setText("jButton1");
        jButton8.setBorderPainted(false);
        jButton8.setContentAreaFilled(false);
        jButton8.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton8.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton8ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton8);

        jButton9.setForeground(new java.awt.Color(255, 255, 204));
        jButton9.setIcon(new ImageIcon("GoldenCutOutimage.png")); // GoldenCutOutimage.png
        jButton9.setText("jButton1");
        jButton9.setBorderPainted(false);
        jButton9.setContentAreaFilled(false);
        jButton9.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton9.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton9ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton9);

        jButton10.setIcon(new ImageIcon("Mango-PerzikCutOutImageDetail.png")); // Mango-PerzikCutOutImageDetail.png
        jButton10.setText("jButton1");
        jButton10.setBorderPainted(false);
        jButton10.setContentAreaFilled(false);
        jButton10.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton10.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton10ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton10);

        jButton11.setForeground(new java.awt.Color(255, 255, 255));
        jButton11.setIcon(new ImageIcon("LeafCutOutImage.png")); // LeafCutOutImage.png
        jButton11.setText("jButton1");
        jButton11.setBorderPainted(false);
        jButton11.setContentAreaFilled(false);
        jButton11.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton11);

        jButton12.setIcon(new ImageIcon("Mango-PerzikCutOutImageDetail.png")); // Mango-PerzikCutOutImageDetail.png
        jButton12.setText("jButton1");
        jButton12.setBorderPainted(false);
        jButton12.setContentAreaFilled(false);
        jButton12.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton12.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton12ActionPerformed(evt);
            }
        });
        jPanelButtons.add(jButton12);

        jSlidersterkte.setOpaque(false);

        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Sterkte");

        jSliderSuiker.setValue(0);
        jSliderSuiker.setOpaque(false);

        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Suiker");

        javax.swing.GroupLayout jPanelMainLayout = new javax.swing.GroupLayout(jPanelMain);
        jPanelMain.setLayout(jPanelMainLayout);
        jPanelMainLayout.setHorizontalGroup(
            jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelMainLayout.createSequentialGroup()
                        .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 260, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(19, 19, 19))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanelMainLayout.createSequentialGroup()
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jPanelButtons, javax.swing.GroupLayout.PREFERRED_SIZE, 350, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanelMainLayout.createSequentialGroup()
                                .addGap(24, 24, 24)
                                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                    .addGroup(jPanelMainLayout.createSequentialGroup()
                                        .addComponent(jLabel1)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jSlidersterkte, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(jPanelMainLayout.createSequentialGroup()
                                        .addComponent(jLabel2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(jSliderSuiker, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 30, Short.MAX_VALUE)
                                .addComponent(jButtonStart)))
                        .addContainerGap())))
        );
        jPanelMainLayout.setVerticalGroup(
            jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanelMainLayout.createSequentialGroup()
                .addGap(62, 62, 62)
                .addComponent(jTextField1, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanelButtons, javax.swing.GroupLayout.PREFERRED_SIZE, 292, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addGap(11, 11, 11)
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jSlidersterkte, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanelMainLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel2)
                            .addComponent(jSliderSuiker, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanelMainLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonStart)))
                .addContainerGap(26, Short.MAX_VALUE))
        );

        jPanelMain.setBounds(0, 0, 400, 520);
        jLayeredPane1.add(jPanelMain, javax.swing.JLayeredPane.DEFAULT_LAYER);

        jLabelBackground.setIcon(new ImageIcon("thee.jpg")); // thee.jpg
        jLabelBackground.setBounds(0, 0, 400, 520);
        jLayeredPane1.add(jLabelBackground, javax.swing.JLayeredPane.DEFAULT_LAYER);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLayeredPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jLayeredPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 521, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        // TODO add your handling code here:
        highlightButton(1);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        highlightButton(2);
    }//GEN-LAST:event_jButton2ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        highlightButton(3);
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // TODO add your handling code here:
        highlightButton(4);
    }//GEN-LAST:event_jButton4ActionPerformed

    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        // TODO add your handling code here:
        highlightButton(5);
    }//GEN-LAST:event_jButton5ActionPerformed

    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        // TODO add your handling code here:
        highlightButton(6);
    }//GEN-LAST:event_jButton6ActionPerformed

    private void jButton7ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton7ActionPerformed
        // TODO add your handling code here:
        highlightButton(7);
}//GEN-LAST:event_jButton7ActionPerformed

    private void jButton8ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton8ActionPerformed
        // TODO add your handling code here:
        highlightButton(8);
}//GEN-LAST:event_jButton8ActionPerformed

    private void jButton9ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton9ActionPerformed
        // TODO add your handling code here:
        highlightButton(9);
}//GEN-LAST:event_jButton9ActionPerformed

    private void jButton10ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton10ActionPerformed
        // TODO add your handling code here:
        highlightButton(10);
}//GEN-LAST:event_jButton10ActionPerformed

    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        // TODO add your handling code here:
        highlightButton(11);
}//GEN-LAST:event_jButton11ActionPerformed

    private void jButton12ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton12ActionPerformed
        // TODO add your handling code here:
        highlightButton(12);
}//GEN-LAST:event_jButton12ActionPerformed

    private void jButtonCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelActionPerformed
        // TODO add your handling code here:
        stopProgress();
}//GEN-LAST:event_jButtonCancelActionPerformed

    private void jButtonStartActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStartActionPerformed
        // TODO add your handling code here:
        if (hide_jPanel_2)
            startProgress("Snel thee zetten...");
        else {
            jPanel_2.setVisible(true);
            jPanelMain.setVisible(false);
        }
    }//GEN-LAST:event_jButtonStartActionPerformed

    private void jButton_p2_verderActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_p2_verderActionPerformed
        // TODO add your handling code here:
        jPanel_2.setVisible(false);
        if (jCheckBoxPanel2_verbergen.isSelected()) {
            hide_jPanel_2 = true;
            System.out.println("jPanel_2 wordt verborgen.");
        }
        startProgress("Thee zetten...");
        
    }//GEN-LAST:event_jButton_p2_verderActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new AutomaatUI().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton10;
    private javax.swing.JButton jButton11;
    private javax.swing.JButton jButton12;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JButton jButton6;
    private javax.swing.JButton jButton7;
    private javax.swing.JButton jButton8;
    private javax.swing.JButton jButton9;
    private javax.swing.JButton jButtonCancel;
    private javax.swing.JButton jButtonStart;
    private javax.swing.JButton jButton_p2_verder;
    private javax.swing.JCheckBox jCheckBoxPanel2_verbergen;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabelBackground;
    private javax.swing.JLayeredPane jLayeredPane1;
    private javax.swing.JPanel jPanelButtons;
    private javax.swing.JPanel jPanelMain;
    private javax.swing.JPanel jPanelProgress;
    private javax.swing.JPanel jPanel_2;
    private javax.swing.JSlider jSliderSuiker;
    private javax.swing.JSlider jSlidersterkte;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    // End of variables declaration//GEN-END:variables

    public void geefProduct() {
    }

    public void setButtonLabel(int x, String label) {
        /*
         * Stel het label van een gegeven knop (nummer) in.
         * 
         * Voor uitleg over het gebruik van getComponent... zie de methode
         * setButtonOutOfStock()
         */
        if (x-1<jPanelButtons.getComponentCount())
            ((JButton)(jPanelButtons.getComponent(x-1))).setText(label);
        else
            System.out.println("setButtonLabel("+x+", "+label+"): foute waarde knopnummer");
    }

    public void displayMessage(String message) {
        jTextField1.setText(message + " Saldo: " + controller.getSaldo());
    }

    public void setButtonOutOfStock(int x) {
        /*
         * Disable een knop waarvan de voorraad op is.
         *
         * Omdat in het Panel jPanelButtons alleen maar knoppen
         * zitten, kunnen we met de getComponent() methode de knoppen
         * rechtstreeks bereiken zoals in deze methode.
         * Let op: dit werkt alleen als er alleen maar knoppen in het Panel
         * zitten!
         * Een andere, omslachtiger manier is mbv. een switch statement
         * de knoppen rechtstreeks aanspreken. Zoals nog in commentaar in de mehtode staat.
         * Dat is duidelijker, maar wel veel meer code...
         */
        if (x-1<jPanelButtons.getComponentCount())
            ((JButton)(jPanelButtons.getComponent(x-1))).setEnabled(false);
        else
            System.out.println("setButtonOutOfStock("+x+"): foute waarde knopnummer");
        /*
        switch (x) {
            case 1: jButton1.setEnabled(false); break;
            case 2: jButton2.setEnabled(false); break;
            case 3: jButton3.setEnabled(false); break;
            case 4: jButton4.setEnabled(false); break;
            case 5: jButton5.setEnabled(false); break;
            case 6: jButton6.setEnabled(false); break;
            case 7: jButton7.setEnabled(false); break;
            case 8: jButton8.setEnabled(false); break;
            case 9: jButton9.setEnabled(false); break;
            case 10: jButton10.setEnabled(false); break;
            case 11: jButton11.setEnabled(false); break;
            case 12: jButton12.setEnabled(false); break;
            default:
                System.out.println("Fout: setButtonOutOfStock(): knop met nummer " + x + " bestaat niet.");
        }
         */
    }

    public void highlightButton(int x) {
        /*
         * Teken een hightlight-randje om de gegeven knop x.
         * (Van alle andere knoppen wordt het randje weer verwijderd)
         */

        // geef de keuze door aan de controller:
        controller.keuze(x-1);

        // borders van alle knoppen in jPanelButtons instellen:
        for (int i=0; i<jPanelButtons.getComponentCount(); i++ ) {
            if ( x-1 == i ) { // als de button degene is die gehighlight moet worden:
                ((JButton)(jPanelButtons.getComponent(i))).setBorder(BorderFactory.createLineBorder(Color.green));
            }
            else { // anders:
                ((JButton)(jPanelButtons.getComponent(i))).setBorder(BorderFactory.createEmptyBorder());
            }
        }
    }
}
