
import java.util.ArrayList;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author F. van Slooten
 *
 * Deze class zorgt voor het voorraadbeheer van de automaat.
 * Hij heeft een lijst met items en een lijst waarin de voorraad voor elk item staat.
 * Hij handelt het kiezen van een item af, en regelt alles rond de betaling.
 *
 */
public class Controller {

    /*
     * Controller voor een snack of frisdrank automaat.
     */
    ArrayList producten; // lijst van producten
    int voorraad[]; // array met hoeveelheid (voorraad) van elk product
    int saldo; // saldo in centen! (waarom niet in double's?: bij docubles zullen door kleine afrondingsvershillen foutjes optreden en bedragen niet meer exact kloppen)
    int gekozenItem; // index van item dat door gebruiker is gekozen, niets gekozen: waarde = -1 of 0 - maxwaarde
    AutomaatUI gui; // referentie naar de gebruikersinterface

    public Controller(AutomaatUI gui) {
        this.gui = gui;
        producten = new ArrayList();
        voorraad = new int[12];
        saldo = 0;
        gekozenItem = -1;

        // Bij het starten gaan we een basisvoorraad aanmaken:
        maakBasisVoorraad();
    }

    public void addItem(String name, int prijs, int buttonNr, int aantalVoorraad) {
        /*
         * Voeg een nieuw item aan de voorraad toe.
         */
        producten.add(new Product(name, prijs));
        //String label = name + " " + prijs + "c";
        String label = name;
        gui.setButtonLabel(buttonNr, label);
        voorraad[buttonNr-1] = aantalVoorraad;
    }

    public void keuze(int keuze) {
        /*
         * Methode die het maken van een keuze afhandeld.
         * Als de gebruiker een item kiest, zal dit als gekozen gemarkeerd worden.
         * Als er genoeg saldo is, zal het item meteen geleverd worden.
         */
        gekozenItem = keuze;
        if (controleerBetaling()) {
            leverProduct();
        }
    }

    public void leverProduct() {
        if (gekozenItem<0) return;

        // Haal het product uit de lijst:
        Product p = ((Product)producten.get(gekozenItem));

        // is er voldoende voorraad van gekozen item?
        if ( voorraad[gekozenItem] < 1) {
            gui.displayMessage( p.getNaam() + " uitverkocht.");
            return;
        }
        voorraad[gekozenItem]--;
        if (voorraad[gekozenItem] <= 0) { // voorraad op?
            gui.setButtonOutOfStock(gekozenItem + 1);
        }

        // bereken wisselgeld:
        int rsaldo = saldo - p.getPrijs();
        int wissel50 = rsaldo / 50;
        rsaldo -= wissel50 * 50;
        int wissel20 = rsaldo / 20;
        rsaldo -= wissel20 * 20;
        int wissel10 = rsaldo / 10;
        rsaldo -= wissel10 * 10;
        System.out.println("Wisselgeld: "+(saldo - p.getPrijs()) + " cent, munten: " + wissel50 + " x 50c, " + wissel20 + " x 20c, " + wissel10 + " x 10c" );


        saldo = 0;
        gekozenItem = -1;
        gui.displayMessage(p.getNaam() + " uitgeleverd.");
    }

    public void updateSaldo(int c) {
        saldo += c;
        gui.displayMessage(getSaldo());
        if (controleerBetaling()) {
            leverProduct();
        }
    }

    public String getSaldo() {
        // Lever het huidige saldo af in een leesbare string in formaat X.XX (euro's)
        return "" + (int) (saldo / 100) + "." + (saldo % 100);
    }

    private boolean controleerBetaling() {
        /*
         * Controleer voor een gekozen item of er voldoende betaald is.
         */
        if (gekozenItem < 0) { // er is nog niets gekozen, controle betaling niet mogelijk
            gui.displayMessage("Maak keuze.");
            return false;
        }

        // Haal het product uit de lijst:
        Product p = ((Product)producten.get(gekozenItem));

        // Als het saldo hoger of gelijk aan de prijs van het gekozen items is,
        // geven we accoord voor de betaling:
        if ( saldo >= p.getPrijs() ) {
            return true;
        }
        gui.displayMessage("Onvoldoende saldo.");
        return false;
    }

    private void maakBasisVoorraad() {
        /*
         * Zet een basisvoorraad in de controller waarmee wordt begonnen:
         */
        addItem("Natural", 0, 1, 2);
        addItem("Groen", 0, 2, 4);
        addItem("Blend", 0, 3, 4);
        addItem("Earl Grey", 0, 4, 7);
        addItem("Sea", 0, 5, 6);
        addItem("Natural", 0, 6, 2);
        addItem("White", 0, 7, 4);
        addItem("Morning", 0, 8, 4);
        addItem("Zoethout", 0, 9, 7);
        addItem("Bosvruchten", 0, 10, 3);
        addItem("MangoPerzik", 0, 11, 5);
        addItem("Puritea", 0, 12, 2);
    }
}
